package com.company.jmix_unfetch.entity;


import io.jmix.core.Entity;
import io.jmix.core.UuidProvider;
import io.jmix.core.entity.annotation.JmixGeneratedValue;
import io.jmix.core.metamodel.annotation.JmixEntity;


import javax.persistence.Column;
import javax.persistence.Id;
import javax.persistence.MappedSuperclass;
import java.util.UUID;

/**
 * Base class for entities with UUID identifier.
 * <p>
 * Inherit from it if you need an entity without optimistic locking, create, update and soft deletion info.
 */
@MappedSuperclass
@JmixEntity(name = "sys_BaseUuidEntity")
public abstract class BaseUuidEntity implements Entity {

    private static final long serialVersionUID = -2217624132287086972L;

    @Id
    @Column(name = "ID", nullable = false)
    @JmixGeneratedValue
    protected UUID id;

    public BaseUuidEntity() {
        this.id = UuidProvider.createUuid();
    }

    public UUID getId() {
        return this.id;
    }

    public void setId(UUID id) {
        this.id = id;
    }

    public UUID getUuid() {
        return this.id;
    }

    public void setUuid(UUID uuid) {
        this.id = this.id;
    }

}
