package com.company.jmix_unfetch.screen.blank;

import com.company.jmix_unfetch.entity.*;
import io.jmix.core.DataManager;
import io.jmix.core.FetchPlan;
import io.jmix.core.SaveContext;
import io.jmix.ui.component.Button;
import io.jmix.ui.screen.Screen;
import io.jmix.ui.screen.Subscribe;
import io.jmix.ui.screen.UiController;
import io.jmix.ui.screen.UiDescriptor;
import org.springframework.beans.factory.annotation.Autowired;

import java.util.ArrayList;
import java.util.List;

@UiController("BlankScreen")
@UiDescriptor("blank-screen.xml")
public class BlankScreen extends Screen {
    @Autowired
    private DataManager dataManager;


    @Subscribe("create")
    public void create(Button.ClickEvent event) {
        MyEntity myEntity = dataManager.create(MyEntity.class);
        LastEntity lastEntity = dataManager.create(LastEntity.class);
        InfoEntity infoEntity = dataManager.create(InfoEntity.class);

        myEntity.getMetaEntity().setLastentity(lastEntity);
        lastEntity.setInfoEntity(infoEntity);

        final SaveContext saveContext = new SaveContext();
        saveContext.getEntitiesToSave().add(myEntity);
        saveContext.getEntitiesToSave().add(lastEntity);
        saveContext.getEntitiesToSave().add(infoEntity);


        dataManager.save(saveContext);
    }

    @Subscribe("read")
    public void onReadClick(Button.ClickEvent event) {
       List<MyEntity> entites =  dataManager.load(MyEntity.class).all().fetchPlan(FetchPlan.BASE).list();
       if(!entites.isEmpty()) {
           MyEntity myEntity = entites.get(0);
           if (myEntity != null) {
               InfoEntity res = myEntity.getMetaEntity().getLastentity().getInfoEntity();
           }
       }
    }
}